grammar arith;

program: start+;

start
    :e=expr {print($e.r)}
    ;

expr returns [r]
    :e=expr '+' p=prod {$r = $e.r + $p.r}
    |p=prod            {$r = $p.r}
    ;

prod returns [r]
    :p=prod '*' pw=pow {$r = $p.r * $pw.r}
    |pw=pow            {$r = $pw.r}
    ;

pow returns [r]
    :b=base '**' pw=pow   {$r = $b.r ** $pw.r}
    |b=base               {$r = $b.r}
    ;

base returns [r]
    :'('e= expr')' {$r = $e.r}
    |n=NUMBER      {$r = int($n.text)}
    ;

NUMBER: '0'|[1-9][0-9]*;
WS: [ \t\n\r] -> skip;
